/*
 *  Bullet.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Thu Apr 08 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include <OpenGL/gl.h>
#include "Object.h"
#include "YourShip.h"
#include "point3d.h"

#ifndef BULLET_H
#define BULLET_H

class Bullet : public Object {
public:
	Bullet(GLfloat *params, YourShip *own=0); // start coord (3), velocity(3)
	~Bullet() {}
	int getDepthPlane() { return kFrontPlane; }
	point3d getLocation();
	void draw();
  uint32_t stepTime(double amount);
	double getRadius();
	void setColor();
	uint32_t testCollision(Object *);
	void destroy();
private:
	void drawSphere(double tRadius, int precision);
	GLfloat param[6];
	YourShip *owner;
	double elapsedTime;
};

#endif