/*
 *  Mine.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Thu Apr 08 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include <OpenGL/gl.h>
#include "Music.h"
#include "Object.h"
#include "point3d.h"

#ifndef MINE_H
#define MINE_H

enum {
	kExploding,
	kArmed,
	kInert
};

class Mine : public Object {
public:
	Mine(GLfloat *params, double time = 30); // start coord (3), velocity(3)
	Mine(GLfloat posx, GLfloat posy, GLfloat posz, GLfloat velx, GLfloat vely, GLfloat velz, double time = 30); // start coord (3), velocity(3)
	~Mine() {}
	int getDepthPlane() { return kFrontPlane; }
	void draw();
  uint32_t stepTime(double amount);
	point3d getLocation();
	double getRadius();
	void setColor();
	uint32_t testCollision(Object *);
	void destroy();
	void activate();
private:
	void drawSphere(double tRadius, int precision);
	GLfloat param[6];
	double elapsedTime;
	int state;
	int fragCount;
	double time;
};

#endif