/*
 *  Music.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Sat Apr 10 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include <QuickTime/QuickTime.h>
#include <QuickTime/QuickTimeComponents.h>
#include <OpenGL/gl.h>
#include "Object.h"

#ifndef MUSIC_H
#define MUSIC_H

enum {
	kPlayOnce=0, // parameter ignored
	kRepeat=1,   // parameter = # times to repeat
	kRepeatRising=2, // parameter = 0xFFFF0000 = times to repeat 0xFFFF = repeat x before rising
	kRepeatSpeedup=3,// parameter = 0xFFFF0000 = times to repeat 0xFFFF = repeat x before rising
	kRepeatRisingSpeedup=4,
	kRepeatSlowdown=5,
	kRepeatRisingSlowdown=6
};

class Music : public Object {
public:
	Music(int *score, int len, int options, uint32_t parameter, int instrument, bool se = true);
	~Music();
	int getDepthPlane() { return kFrontPlane; }
	void draw() { }
  uint32_t stepTime(double amount);
	void destroy();
	void setPitchOffset(int val);
private:
	int *score;
	double elapsedTime;
	int length;
	int timesRepeated;
	int repeatDir;
	int currentNote;
	int timesPlayed;
	int maxTimesPlayed;
	int fReturnValue;
	int offset;
  bool soundEffect;
	double speed, speedFactor;
	bool done;
	NoteAllocator na;
	NoteChannel nc;
	NoteRequest nr;
};

#endif
