/*
 *  waygate.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Thu Apr 08 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include <OpenGL/gl.h>
#include "vector3d.h"
#include "point3d.h"
#include "Object.h"
#include "Music.h"

#ifndef WAYGATE_H
#define WAYGATE_H

class WayGate : public Object {
public:
	WayGate(GLfloat locx, GLfloat locy, GLfloat locz, GLfloat rotx, GLfloat roty, GLfloat rotz, double radius, int resolution);
	~WayGate() {}
	int getDepthPlane() { return kFrontPlane; }
	void draw();
  uint32_t stepTime(double amount);
	double getRadius() { return 1.1*radius; }
	point3d getLocation();
	void setColor();
	void lock();
	void unlock();
	uint32_t testCollision(Object *);
	void destroy();
	Object *getNewObject();
private:
	double elapsedTime;
	double res;
	double radius;
	GLfloat pos[3];
	GLfloat rot[3];
	bool locked;
	//Music *passedMusic;
	point3d n1, n2; // normals used for collision detection
};

#endif