/*
 *  World.h
 *  Carbon OpenGL
 *
 *  Created by Nathan Sturtevant on Wed Mar 24 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include <vector>
#include "Object.h"

#ifndef WORLD_H
#define WORLD_H

class World {
public:
	World();
	~World();
	void reset();
	void addObject(Object *obj);
	void stepTime(double amount);
	void draw();
	void drawDisplayObjs(); // for when paused?
	void drawOverview(); // just put in a point for each thing in the world
private:
	std::vector<Object *> otherObjs;
	std::vector<Object *> displayObjs;
  std::vector<Object *> disabledObjs;
};

#endif
