/*
 *  YourShip.h
 *  Racer
 *
 *  Created by Nathan Sturtevant on Sun Apr 11 2004.
 *  Copyright (c) 2004 NS Software. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include <OpenGL/gl.h>
#include "Object.h"
#include "point3d.h"
#include "Mine.h"
#include "Music.h"
#include "TextBox.h"

#ifndef YOURSHIP_H
#define YOURSHIP_H

enum tViewpoint {
	kRear=0,
	kTop=1,
	kSide=2
};

class YourShip : public Object {
public:
	YourShip();
	~YourShip() {}
	int getDepthPlane() { return kFrontPlane; }
	bool isAlive();
	bool passedLevel();
	void draw();
	void setupViewpoint();
	void setupOverviewpoint();
	tViewpoint getOverviewpoint();
	void rotateOverviewpoint();
	void drawStatus();
  uint32_t stepTime(double amount);
	void addRotation(GLfloat *rot);
	void dropMine();
	void shoot();
	void setMusic(Music *m) { gameMusic = m; }
	int getScore();
  void addToScore(int score);
	int getTime();
	Object *getNewObject();
	point3d getLocation() { return viewPos; }
	double getRadius() { return 0.1; }
	void setColor();
	uint32_t testCollision(Object *);
	void destroy();
	void activate();
private:
	void handleKeyboard(double rotation, double speed, double stop);
	void getHeading(GLfloat &hx, GLfloat &hy, GLfloat &hz);
	void rotation2Quat(float *A, float *q);
	bool isPressed(unsigned short k);
	double elapsedTime;
	GLfloat fVel[3];
	GLfloat fRot[4];
	point3d viewPos;
	vector3d heading;
//	Music *dieMusic, *deathSound, *shootSound, *mineSound;
//	TextBox *dieMessage;
	Music *gameMusic;
//	Mine *mine;
//	int fragCount;
	double shotPower;
	double deathTime;
	int numMines;
  int currentScore;
	bool alive;
	tViewpoint viewRotate;
};

#endif
